package com.bonus.zlpt.auth.controller;

import javax.servlet.http.HttpServletRequest;

import com.bonus.zlpt.auth.form.RegisterBody;
import com.bonus.zlpt.common.core.enums.UserStatus;
import com.bonus.zlpt.system.api.domain.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.bonus.zlpt.auth.form.LoginBody;
import com.bonus.zlpt.auth.service.SysLoginService;
import com.bonus.zlpt.common.core.domain.R;
import com.bonus.zlpt.common.core.utils.JwtUtils;
import com.bonus.zlpt.common.core.utils.StringUtils;
import com.bonus.zlpt.common.security.auth.AuthUtil;
import com.bonus.zlpt.common.security.service.TokenService;
import com.bonus.zlpt.common.security.utils.SecurityUtils;
import com.bonus.zlpt.system.api.model.LoginUser;

import java.util.Date;

/**
 * token 控制
 * 
 * @author ruoyi
 */
@RestController
public class TokenController
{
    @Autowired
    private TokenService tokenService;

    @Autowired
    private SysLoginService sysLoginService;

    @PostMapping("login")
    public R<?> login(@RequestBody LoginBody form)
    {
        // 用户登录
        LoginUser userInfo = sysLoginService.login(form.getUsername(), form.getPassword());
        // 获取登录token
        return R.ok(tokenService.createToken(userInfo));
    }

    @DeleteMapping("logout")
    public R<?> logout(HttpServletRequest request)
    {
        String token = SecurityUtils.getToken(request);
        if (StringUtils.isNotEmpty(token))
        {
            String username = JwtUtils.getUserName(token);
            // 删除用户缓存记录
            AuthUtil.logoutByToken(token);
            // 记录用户退出日志
            sysLoginService.logout(username);
        }
        return R.ok();
    }

    @PostMapping("refresh")
    public R<?> refresh(HttpServletRequest request)
    {
        LoginUser loginUser = tokenService.getLoginUser(request);
        if (StringUtils.isNotNull(loginUser))
        {
            // 刷新令牌有效期
            tokenService.refreshToken(loginUser);
            return R.ok();
        }
        return R.ok();
    }

    @PostMapping("register")
    public R<?> register(@RequestBody RegisterBody registerBody)
    {
        // 用户注册
        sysLoginService.register(registerBody.getUsername(), registerBody.getPassword());
        return R.ok();
    }


    /**
     * 用户注销
     * @param
     * @return
     */
    @PostMapping ("logOff")
    public R<?> logOff(@RequestBody SysUser user)
    {

        user.setLoginDate(new Date());
        user.setDelFlag(UserStatus.DELETED.getCode());
        sysLoginService.logOff(user);
        return R.ok();
    }


    /**
     * 用户注销
     * @param
     * @return
     */
    @PostMapping ("revokeLogOff")
    public R<?> revokeLogOff(@RequestBody SysUser user)
    {

        user.setLoginDate(new Date());
        user.setDelFlag(UserStatus.OK.getCode());
        sysLoginService.logOff(user);
        return R.ok();
    }
}
